<?php
/**
* @version      $Id: time.php 1.0 2011-08-24 Rehne $
* @package      FLEXIcontent 1.5.6
* @author      	Rene Bz
* @copyright   	Copyright (C) 2011 nettdotkomm. All rights reserved.
* @license      GNU/GPL v2
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

//jimport('joomla.plugin.plugin');
jimport('joomla.event.plugin');

class plgFlexicontent_fieldsTime extends JPlugin
{
	function plgFlexicontent_fieldsTime( &$subject, $params )
	{
		parent::__construct( $subject, $params );
         JPlugin::loadLanguage('plg_flexicontent_fields_text', JPATH_ADMINISTRATOR);
	}

	function onDisplayField(&$field, $item)
 	{
		$field->label = JText::_($field->label);
		// execute the code only if the field type match the plugin type
		if($field->field_type != 'time') return;

		// some parameter shortcuts
		$required 			= $field->parameters->get( 'required', 0 ) ;




		$multiple			= $field->parameters->get( 'allow_multiple', 1 ) ;
		$maxval				= $field->parameters->get( 'max_values', 0 ) ;




		$required 	= $required ? ' required' : '';

		// initialise property
     


		if (!$field->value) {
			$field->value = array();
			$field->value[0] = '';
		}





		if ($multiple) // handle multiple records
		{
			$document	= & JFactory::getDocument();

			//add the drag and drop sorting feature
			$js = "
			window.addEvent('domready', function(){
				new Sortables($('sortables_".$field->id."'), {
					'constrain': true,
					'clone': true,
					'handle': '.drag".$field->id."'
					});			
				});
			";
			$document->addScript( JURI::root().'administrator/components/com_flexicontent/assets/js/sortables.js' );
			$document->addScriptDeclaration($js);

			$js = "
			var curRowNum".$field->id."	= ".count($field->value).";
			var maxVal".$field->id."		= ".$maxval.";

			function addField".$field->id."(el) {
				if((curRowNum".$field->id." < maxVal".$field->id.") || (maxVal".$field->id." == 0)) {

					var thisField 	 = $(el).getPrevious().getLast();
					var thisNewField = thisField.clone();
					var fx			 = thisNewField.effects({duration: 0, transition: Fx.Transitions.linear});
					thisNewField.getFirst().setProperty('value','');

					thisNewField.injectAfter(thisField);
		
					new Sortables($('sortables_".$field->id."'), {
						'constrain': true,
						'clone': true,
						'handle': '.drag".$field->id."'
					});			

					fx.start({ 'opacity': 1 }).chain(function(){
						this.setOptions({duration: 600});
						this.start({ 'opacity': 0 });
						})
						.chain(function(){
							this.setOptions({duration: 300});
							this.start({ 'opacity': 1 });
						});

					curRowNum".$field->id."++;
					}
				}

			function deleteField".$field->id."(el) {
				if(curRowNum".$field->id." > 1) {

				var field	= $(el);
				var row		= field.getParent();
				var fx		= row.effects({duration: 300, transition: Fx.Transitions.linear});
				
				fx.start({
					'height': 0,
					'opacity': 0			
					}).chain(function(){
						row.remove();
					});
				curRowNum".$field->id."--;
				}
			}
			";
			$document->addScriptDeclaration($js);
			
			$css = '
			#sortables_'.$field->id.' { margin: 0px; padding: 0px; list-style: none; white-space: nowrap; }
			#sortables_'.$field->id.' li {
				list-style: none;
				height: 20px;
				}
			#sortables_'.$field->id.' li input { cursor: text;}
			#sortables_'.$field->id.' li input.fcbutton, .fcbutton { cursor: pointer; margin-left: 3px; }
			span.drag'.$field->id.' img {
				margin: -4px 8px;
				cursor: move;
			}
			';
			$document->addStyleDeclaration($css);

			$move2 	= JHTML::image ( 'administrator/components/com_flexicontent/assets/images/move3.png', JText::_( 'FLEXI_CLICK_TO_DRAG' ) );
			$n = 0;
			$field->html = '<ul id="sortables_'.$field->id.'">';

			foreach ($field->value as $value) {
				$field->html	.= '<li>'.$pretext.'<input name="'.$field->name.'[]" id="'.$field->name.'" class="inputbox'.$required.'" type="text" size="'.$size.'" value="'.$value.'"'.$required.' />'.$posttext.'<input class="fcbutton" type="button" value="'.JText::_( 'FLEXI_REMOVE_VALUE' ).'" onclick="deleteField'.$field->id.'(this);" /><span class="drag'.$field->id.'">'.$move2.'</span></li>';
				$n++;
				}
			$field->html .=	'</ul>';
			$field->html .= '<input type="button" id="add'.$field->name.'" onclick="addField'.$field->id.'(this);" value="'.JText::_( 'FLEXI_ADD_VALUE' ).'" />';

		} else { // handle single records
			$field->html	= '<div>'.$pretext.'<input name="'.$field->name.'[]" id="'.$field->name.'" class="inputbox'.$required.'" type="text" size="'.$size.'" value="'.$field->value[0].'"'.$required.' />'.$posttext.'</div>';
		}
	}


	function onBeforeSaveField( $field, &$post, &$file )
	{
		// execute the code only if the field type match the plugin type
		if($field->field_type != 'time') return;
		if(!$post) return;
		
		$newpost = array();
		$new = 0;

      foreach ($post as $n=>$v)
      {
         if ($v != '')
         {
            // validate:
            $vParts = explode('h', $v);
            if (count($vParts < 2)) {
               if (strlen($vParts[0]) > 2) {
                  $vParts = array(substr($v, 0, -2), substr($v, -2));
               }
               else {
                  $vParts[] = '00';
               }
            }
            $vParts[0] = (int) $vParts[0];
            $vParts[1] = (int) $vParts[1];
            if ($vParts[0] > 23)
               $vParts[0] = 0;
            if ($vParts[1] > 59)
               $vParts[1] = 0;
            if ($vParts[0] < 10)
               $vParts[0] = '0' . $vParts[0];
            if ($vParts[1] < 10)
               $vParts[1] = '0' . $vParts[1];
            
            $newpost[$new] = $vParts[0] . ':' . $vParts[1];
         }
         $new++;
      }
      $post = $newpost;
   }


	function onDisplayFieldValue(&$field, $item, $values=null, $prop='display')
	{

		// some parameter shortcuts

		$separatorf 		= $field->parameters->get( 'separatorf', 1 ) ;

      switch($separatorf)
      {
         case 0:
         $separatorf = '&nbsp;';
         break;

         case 1:
         $separatorf = '<br />';
         break;

         case 2:
         $separatorf = '&nbsp;|&nbsp;';
         break;

         case 3:
         $separatorf = ',&nbsp;';
         break;

         default:
         $separatorf = '&nbsp;';
         break;
      }
      
      
      
      
      $field->label = JText::_($field->label);
      // execute the code only if the field type match the plugin type
      if($field->field_type != 'time') return;
                              
      $field->{$prop}   = $field->value ? $field->value : JText::_( 'FLEXI_NO_VALUE' );
      
      $n=0;
	  

		if($values != 0)
		{
		
		  foreach ($values as $value) {
			 $field->{$prop}[]   = $values[$n] ? JHTML::_('time', $values[$n] ) : JText::_( 'FLEXI_NO_VALUE' );
			 
			 $n++;
			 }
			 $field->{$prop} = implode($separatorf, $field->{$prop});
		}
   }
}
?>